function [Mi,J] = calc_inverse_M_s(Ms)
%%  calculate uncertain inverse motion and Jacobian
%   exponential representation
%
% Ms     motion, Ms.Ms = [4x4], Ms.Cs = [6x6]
%
% Mi     inverse motion, Mi.Ms = [4x4], Mi.Cs = [6x6]
% J      [6x6] Jacobian
% 
% wf 6/2020

% Motion
M0    = Ms.Ms;
% inverse motion
Mi.Ms = inv(M0);
% Jacobian (neg. inverse adjunct motion matrix)
R0    = M0(1:3,1:3);
J     = -[R0' zeros(3); R0'*calc_S(M0(1:3,4))' R0'];
% CovM
Mi.Cs = J*Ms.Cs*J';

end

